Codeforces Round #631 (Div. 2) - Thanks, Denis aramis Shitov! D. Dreamoon Likes Sequences(打表找规律)

D. Dreamoon Likes Sequences

time limit per test

1 second

memory limit per test

256 megabytes

input

standard input

output

standard output

Dreamoon likes sequences very much. So he created a problem about the sequence that you can't find in OEIS:

You are given two integers d,md,m, find the number of arrays aa, satisfying the following constraints:

  • The length of aa is nn, n≥1n≥1
  • 1≤a1<a2<⋯<an≤d1≤a1<a2<⋯<an≤d
  • Define an array bb of length nn as follows: b1=a1b1=a1, ∀i>1,bi=bi−1⊕ai∀i>1,bi=bi−1⊕ai, where ⊕⊕ is the bitwise exclusive-or (xor). After constructing an array bb, the constraint b1<b2<⋯<bn−1<bnb1<b2<⋯<bn−1<bn should hold.

Since the number of possible arrays may be too large, you need to find the answer modulo mm.

Input

The first line contains an integer tt (1≤t≤1001≤t≤100) denoting the number of test cases in the input.

Each of the next tt lines contains two integers d,md,m (1≤d,m≤1091≤d,m≤109).

Note that mm is not necessary the prime!

Output

For each test case, print the number of arrays aa, satisfying all given constrains, modulo mm.

Example

input

Copy

10
1 1000000000
2 999999999
3 99999998
4 9999997
5 999996
6 99995
7 9994
8 993
9 92
10 1

output

Copy

1
3
5
11
17
23
29
59
89
0

题意:给你一个数n(<=1e9)和模数mod(<=1e9),对于一个序列,若这个序列是严格递增的,且最大的数不超过n,且它的前缀异或值也是递增的,那么这个序列就是合法序列。T组数据,每组n和m,输出n相应的合法的序列总数%mod。

思路:直接打表,规律很明显。(代码中附打表代码)注意取模!注意取模!注意取模!!!!!!!!

代码:

#include<bits/stdc++.h>
#define ll long long
#define inf 0x3f3f3f3f
#define rep(i,a,b) for(register int i=(a);i<=(b);i++)
#define dep(i,a,b) for(register int i=(a);i>=(b);i--)
using namespace std;
const int maxn=400010;
int m,q,k,ct;
ll n,mo;
int a[maxn];
void dfs(int x,int xr){
    a[x]++;
    for(int i=x+1;i<=20;i++){
        if((xr^i)>xr) dfs(i,xr^i);
    }
}
int main()
{
    //下面这段是打表代码
    /*dfs(0,0);
    rep(i,1,20)
    {
        if(i>1)a[i]+=a[i-1];
        cout<<i<<" "<<a[i]<<" "<<a[i]-a[i-1]<<endl;
    }*/
    int T,cas=1;
    scanf("%d",&T);
    while(T--)
    {
        scanf("%lld%lld",&n,&mo);
        ll i=1,sum=1,k=1,num=1;
        while(i<n){
            k=k*(num+1)%mo;
            num<<=1;
            if(i+num>=n) {sum=(sum+(n-i)*k%mo)%mo;break;}
            else {i+=num;sum=(sum+num*k%mo)%mo;}
        }
        printf("%lld\n",sum%mo);
    }
    return 0;
}

 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
题目描述 给定一棵 $n$ 个节点的树,每个节点都有一个权值 $w_i$。你需要删去树上的一些边,使得剩下的每个连通块中,所有节点的权值之和不超过 $k$。 求最多能删去多少条边。 输入格式 第一行包含两个整数 $n,k$。 第二行包含 $n$ 个整数 $w_1,w_2,\cdots,w_n$。 接下来 $n-1$ 行,每行包含两个整数 $a,b$,表示节点 $a$ 和节点 $b$ 之间有一条边。 输出格式 输出一个整数,表示最多能删去的边数。 数据范围 $1\le n \le 10^5$ $1 \le k,w_i \le 10^9$ 输入样例1: 5 6 2 3 1 5 4 1 2 1 3 2 4 2 5 输出样例1: 2 输入样例2: 5 3 2 3 1 5 4 1 2 1 3 2 4 2 5 输出样例2: 0 算法1 (dfs) $O(n)$ 首先我们可以想到暴力的做法,即对于每个连通块,暴力枚举删去哪些边,尝试得到最多的删边数。那么如何求解一个连通块内的所有节点权值之和呢?我们可以使用 DFS 遍历树,对于每个节点,求出其子树内所有节点的权值之和,那么以该节点为根的子树内的所有节点权值之和就是该节点自身的权值加上其所有子节点的权值之和。 对于每个连通块,我们枚举该连通块内任意两个节点 $x,y$。如果 $x$ 与 $y$ 之间的路径上的所有边都被删去了,那么 $x$ 和 $y$ 就会分别成为两个新的连通块,这两个新的连通块内所有节点的权值之和都不超过 $k$。因此我们只需要枚举所有的 $x,y$ 对,对于每个 $x,y$ 对尝试删去它们之间的路径上的所有边,看是否能够让 $x$ 和 $y$ 成为两个新的连通块,进而更新答案即可。 时间复杂度 参考文献 python3 代码 算法2 (暴力枚举) $O(n^2)$ blablabla 时间复杂度 参考文献 C++ 代码 class Solution { public: const int N = 1e5+10; int n,k; int h[N],e[N<<1],ne[N<<1],idx; int w[N]; int sum[N]; bool st[N]; int res; void add(int a,int b) { e[idx] = b,ne[idx] = h[a],h[a] = idx++; } void dfs(int u,int father) { sum[u] = w[u]; for(int i=h[u];~i;i=ne[i]) { int j = e[i]; if(j == father) continue; dfs(j,u); sum[u] += sum[j]; } } void dfs2(int u,int father) { for(int i=h[u];~i;i=ne[i]) { int j = e[i]; if(j == father) continue; dfs2(j,u); if(sum[j] <= k) res++; else if(sum[u] - sum[j] <= k) res++; } } void solve() { cin >> n >> k; memset(h,-1,sizeof(h)); for(int i=1;i<=n;i++) cin >> w[i]; for(int i=1;i<n;i++) { int a,b; cin >> a >> b; add(a,b); add(b,a); } dfs(1,-1); dfs2(1,-1); cout << res << endl; } }; int main() { Solution().solve(); return 0; }

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值